# Copyright (C) 2019-2020 VMware, Inc. All rights reserved.
# -- VMware Confidential


def stable_condition(connection_list, p):
    # two cases should be treat as stable and clear alarm
    # 1. if not get any connection (connection_list is None or empty list)
    # 2. if all connections are stable
    if not connection_list:
        return True
    return all(map(lambda connection: connection['stable'] is True, connection_list))


def unstable_condition(connection_list, p):
    return connection_list and any(map(lambda connection: connection['stable'] is False, connection_list))


logger.debug('data_store:{}'.format(data_store))
metric_name = 'nsx.hyperbus.hyperbus-connection-list'
profile = data_store['profile']
evt_type_id = feature_event_type_mappings.NODE_AGENTS_HEALTH_NODE_AGENTS_DOWN_EVENT_TYPE_ID

if data_store['metrics'][metric_name] is not None:
    connection_list = data_store['metrics'][metric_name]['value']
    Nareport(connection_list=connection_list, profile=profile)

    if stable_condition(connection_list, profile):
        Alarm(status={evt_type_id: {data_store['host_id']: (False, None)}}, feature="node_agents_health")
    if unstable_condition(connection_list, profile):
        Alarm(status={evt_type_id: {data_store['host_id']: (True, None)}}, feature="node_agents_health")
else:
    logger.info('Metric {} is None from whiteboard, data_store:{}'.format(metric_name, data_store))


